package be.iminds.ilabt.jfed.experimenter_gui.canvas.impl;

import be.iminds.ilabt.jfed.experimenter_gui.canvas.CanvasNode;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.ExperimentCanvas;
import be.iminds.ilabt.jfed.experimenter_gui.gts_editor.EditableGtsDsl;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXGeantTestbedType;
import javafx.scene.image.Image;

/**
 * User: twalcari
 * Date: 4/23/2015
 * Time: 15:21
 */
public class RspecGTSNode extends CanvasNode {

    private final FXGeantTestbedType gtt;
    private final EditableGtsDsl editableGtsDsl;

    public RspecGTSNode(FXGeantTestbedType gtt, ExperimentCanvas experimentCanvas) {
        super(experimentCanvas, gtt.getName(), new Image(ImageUtil.class.getResource("/images/gts-cloud.png").toExternalForm()));
        this.gtt = gtt;

        this.editableGtsDsl = new EditableGtsDsl(gtt.getName());
        editableGtsDsl.nameProperty().bindBidirectional(gtt.nameProperty());

        editableGtsDsl.dslProperty().addListener(observable -> {
            gtt.setDsl(editableGtsDsl.getDsl());
        });

        textProperty().bind(gtt.nameProperty());

        layoutXProperty().bindBidirectional(gtt.editorXProperty());
        layoutYProperty().bindBidirectional(gtt.editorYProperty());

        experimentCanvas.getCanvas().getChildren().add(this);
    }

    public FXGeantTestbedType getGeantTestbedType() {
        return gtt;
    }

    /**
     * Should be called when the RspecCanvasLink is removed from the canvas
     */
    public void remove() {
        experimentCanvas.getCanvas().getChildren().remove(this);
    }

    public EditableGtsDsl getEditableGtsDsl() {
        return editableGtsDsl;
    }
}
