package be.iminds.ilabt.jfed.experimenter_gui.slice;

import be.iminds.ilabt.jfed.experimenter_gui.call_gui.TasksWindow;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.ExperimentTasksFactory;
import be.iminds.ilabt.jfed.preferences.JFedGuiPreferences;
import com.google.common.eventbus.EventBus;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 2/5/2015
 * Time: 11:08
 */
@Singleton
public class ExperimentViewControllerFactory {

    private final ExperimentControllerFactory experimentControllerFactory;
    private final ExperimentViewsFactory experimentViewsFactory;
    private final JFedGuiPreferences jFedPreferences;
    private final TasksWindow tasksWindow;
    private final ExperimentTasksFactory experimentTasksFactory;
    private final EventBus eventBus;

    @Inject
    public ExperimentViewControllerFactory(ExperimentControllerFactory experimentControllerFactory,
                                           ExperimentViewsFactory experimentViewsFactory, JFedGuiPreferences jFedPreferences,
                                           TasksWindow tasksWindow, ExperimentTasksFactory experimentTasksFactory, EventBus eventBus) {
        this.experimentControllerFactory = experimentControllerFactory;
        this.experimentViewsFactory = experimentViewsFactory;
        this.jFedPreferences = jFedPreferences;
        this.tasksWindow = tasksWindow;
        this.experimentTasksFactory = experimentTasksFactory;
        this.eventBus = eventBus;
    }

    public ExperimentViewController createExperimentViewController(ExperimentController experimentController){
        return new ExperimentViewController(experimentController, experimentViewsFactory, tasksWindow, jFedPreferences, experimentTasksFactory, eventBus);

    }

    public ExperimentViewController createExperimentViewController(Experiment experiment){
        return createExperimentViewController(experimentControllerFactory.createExperimentController(experiment));
    }


}
