package be.iminds.ilabt.jfed.experimenter_gui.slice.progress;

import be.iminds.ilabt.jfed.experimenter_gui.ui.status.TaskStatusIndicator;
import javafx.concurrent.Task;

/**
 * User: twalcari
 * Date: 3/5/14
 * Time: 11:28 AM
 */
public abstract class ProgressTask<V> extends Task<V> {

    protected final ProgressItem progressItem;

    protected ProgressTask(ProgressView progressView, String text, TaskStatusIndicator.Status status) {
        this.progressItem = new ProgressItem(text, status);
        progressView.getItems().add(progressItem);
    }

    protected ProgressTask(ProgressView progressView, String text) {
        this(progressView, text, TaskStatusIndicator.Status.INACTIVE);
    }

    @Override
    protected void running() {
        progressItem.setProgress(TaskStatusIndicator.Status.BUSY);
    }

    @Override
    protected void succeeded() {
        progressItem.setProgress(TaskStatusIndicator.Status.SUCCESS);
    }

    @Override
    protected void cancelled() {
        progressItem.setProgress(TaskStatusIndicator.Status.WARNING);
    }

    @Override
    protected void failed() {
        progressItem.setProgress(TaskStatusIndicator.Status.FAILED);
    }
}
