package be.iminds.ilabt.jfed.lowlevel.authority;

import be.iminds.ilabt.jfed.util.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;

/*
*
* Hint: to fetch server SSL certificates in PEM format, you can use openssl like this:
*    openssl s_client -showcerts -connect <hostname>:<port> -prexit
*
* */

public class BuiltinAuthorityList {
    private final static Logger LOG = LoggerFactory.getLogger(BuiltinAuthorityList.class);

    private BuiltinAuthorityList() {
    }

    public static void load(AuthorityListModel authorityListModel) {
        LOG.debug("Loading the builtin testbeds.xml (might not be up to date)");
        try {
            String content = IOUtils.resourceToString("testbeds.xml", BuiltinAuthorityList.class);
            StoredAuthorityList.load(content, authorityListModel);
        } catch (IOException e) {
            LOG.error("IOException getting builtin testbeds.xml", e);
            return;
        }
    }
}
